:- modeh(1,illegal(+conf)).             % conf = main key

:- modeb(1,king1_rank(+conf,-rank)).
:- modeb(1,king1_file(+conf,-file)).

:- modeb(1,rook_rank(+conf,-rank)).
:- modeb(1,rook_file(+conf,-file)).

:- modeb(1,king2_rank(+conf,-rank)).
:- modeb(1,king2_file(+conf,-file)).

:- modeb(1,lt(+rank,+rank)).
:- modeb(1,lt(+file,+file)).

:- modeb(1,adj(+rank,+rank)).
:- modeb(1,adj(+file,+file)).

% settings considered by "featurize.pl":
:-set(clauselength,5).  %max no of literals in feature
:-set(depth,2).         %depth of vars

% settings considered by "process.pl"
:-set(negation,now).    % generate also negated versions of features

% settings considered by "rules.pl"
:-set(eval_threshold,0.001). % wracc threshold
:-set(sig_threshold,9.21).  % determined by chi^2 value table for 99% sig. level
:-set(beam_width,1).

%%%% BACKGROUND KNOWLEDGE %%%%%%%%%%%%%

king1_rank(conf(R,_,_,_,_,_),R).
king1_file(conf(_,F,_,_,_,_),F).

rook_rank(conf(_,_,R,_,_,_),R).
rook_file(conf(_,_,_,F,_,_),F).

king2_rank(conf(_,_,_,_,R,_),R).
king2_file(conf(_,_,_,_,_,F),F).

lt(0,1).
lt(0,2).
lt(0,3).
lt(0,4).
lt(0,5).
lt(0,6).
lt(0,7).
lt(1,2).
lt(1,3).
lt(1,4).
lt(1,5).
lt(1,6).
lt(1,7).
lt(2,3).
lt(2,4).
lt(2,5).
lt(2,6).
lt(2,7).
lt(3,4).
lt(3,5).
lt(3,6).
lt(3,7).
lt(4,5).
lt(4,6).
lt(4,7).
lt(5,6).
lt(5,7).
lt(6,7).

% adj(R/C,R/C)
adj(0,0).
adj(1,1).
adj(2,2).
adj(3,3).
adj(4,4).
adj(5,5).
adj(6,6).
adj(7,7).
adj(0,1).
adj(1,2).
adj(2,3).
adj(3,4).
adj(4,5).
adj(5,6).
adj(6,7).
adj(7,6).
adj(6,5).
adj(5,4).
adj(4,3).
adj(3,2).
adj(2,1).
adj(1,0).
